﻿import es,popuplib,playerlib

info = es.AddonInfo()
info.name = "Статистика для игроков под UCP Античит"
info.version = "1.00"
info.author = "Mixer57"
info.basename = "plstat"
info.url = "http://www.Mixer57.ru/"
info.description = "Позволяет игрокам следить за качеством своей игры."
es.ServerVar(info.basename+'_ver',info.version,info.basename+' Version').makepublic()

# dicts
ids = {} # UCP_ID by ID
dead = {} # Deaths by UCP_ID
kill = {} # Kills by UCP_ID
skill = {} # skills by UCP_ID
hs = {} # HeadShots by UCP_ID
bp = {} # Bombs Planted by UCP_ID
bd = {} # Bombs Defused by UCP_ID
bb = {} # Bombs Bombed by UCP_ID
hosa= {} # Hostage Saved by UCP_ID
sh = {} # Shoots by UCP_ID
weaponlist = ["glock",	"usp","p228","deagle","fiveseven","elite","m3","xm1014","mac10","tmp","mp5","ump45",
			"p90","famas","galil","scout","m4a1","ak47","aug","sg552","sg550","g3sg1","awp","m249"]

def load():
	es.sql("open","base","|plstat")
	es.sql("query","base","CREATE TABLE IF NOT EXISTS players (ucpid VARCHAR NOT NULL, name VARCHAR DEFAULT '',kills INTEGER DEFAULT '0',deaths INTEGER DEFAULT '0',skill DOUBLE DEFAULT '0.0',hs INTEGER DEFAULT '0',bp INTEGER DEFAULT '0',bd INTEGER DEFAULT '0',bb INTEGER DEFAULT '0',hosa INTEGER DEFAULT '0',sh INTEGER DEFAULT '0');CREATE UNIQUE INDEX IF NOT EXISTS [keys] ON [players] ([ucpid], [name]);")
	es.sql("query","base","CREATE TABLE IF NOT EXISTS wep (ucpid VARCHAR NOT NULL,weapon VARCHAR DEFAULT '',val INTEGER DEFAULT 0);")
	plys = es.getUseridList()
	for ply in plys:
		uid = getUCPID(ply)
		if uid != 0 and uid != None:
			name = es.getplayername(ply)
			check = es.sql("queryvalue","base","select * from players where ucpid='%s'" % uid)
			wepcheck = es.sql("queryvalue","base","select * from wep where ucpid='%s'" % uid)
			if check == None:es.sql("query","base","insert into players(ucpid,name) values('%s','%s');" % (uid, name))
			if wepcheck == None:insertwep(uid)
			kill[uid] =    int(es.sql("queryvalue","base","select kills from players where ucpid='%s'" % uid))
			dead[uid] =    int(es.sql("queryvalue","base","select deaths from players where ucpid='%s'" % uid))
			skill[uid] = float(es.sql("queryvalue","base","select skill from players where ucpid='%s'" % uid))
			hs[uid] =      int(es.sql("queryvalue","base","select hs from players where ucpid='%s'" % uid))
			bp[uid] =  int(es.sql("queryvalue","base","select bp from players where ucpid='%s'" % uid))
			bd[uid] =  int(es.sql("queryvalue","base","select bd from players where ucpid='%s'" % uid))
			bb[uid] =  int(es.sql("queryvalue","base","select bb from players where ucpid='%s'" % uid))
			hosa[uid] =    int(es.sql("queryvalue","base","select hosa from players where ucpid='%s'" % uid))
			sh[uid] =      int(es.sql("queryvalue","base","select sh from players where ucpid='%s'" % uid))
	es.regsaycmd("стат", "plstat/showstat", "")
	es.regsaycmd("stat", "plstat/showstat", "")
def unload():
	es.unregsaycmd("стат")
	es.unregsaycmd("stat")
	es.sql("close","base")
# Functions =====================================
def msg(Text):
	es.msg('#multi', "#green[Стат]#lightgreen %s"%Text)
def tell(User, Text):
	es.tell(User, '#multi', "#green[Стат]#lightgreen %s"%Text)
def insertwep(uid):
	que = ""
	for weps in weaponlist:
		que += "insert into wep(ucpid,weapon) values('%s','weapon_%s');" % (uid, weps)
	es.sql("query","base",que)
def getUCPID(id):
	global ids
	# Возвращает UID игрока.
	uid = 0
	if id == 0: return 0
	name = es.getplayername(id)
	ply = playerlib.getPlayer(id)
	if ply.isbot: return 0
	uid = es.getclientvar(id, "*ucp_id")
	if uid == None: uid = 0 
	if name not in ids: ids[name] = 0 
	ids[name] = uid
	return uid
def add_kill(id, val, is_hs):
	uid = ids.get(id,0)
	if uid != 0:
		if uid not in kill: kill[uid] = 0 
		kill[uid] += val
		if uid not in hs: hs[uid] = 0
		hs[uid] += int(is_hs)
		if hs.get(uid) < 0: hs[uid] = 0
		if kill.get(uid) < 0: kill[uid] = 0
		update(uid)
def add_dead(id):
	uid = ids.get(id,0)
	if uid != 0:
		if uid not in dead: dead[uid] = 0 
		dead[uid] += 1
		update(uid)
def showstat():
	id = es.getcmduserid()
	name = es.getplayername(id)
	uid = ids.get(name,0)
	stat = popuplib.create("stat")
	lwep = es.sql("queryvalue","base","select weapon from wep where ucpid='%s' order by val desc limit 1;" % uid)
	olwep = conwep(lwep)
	stat.editlang = "ru"
	stat.addline("Статистика %s:" % name)
	#stat.addline("Ucp_ID %s" % uid)
	stat.addline("-"*20)
	if uid != 0:
		stat.addline("Навык: %s" % skill.get(uid))
		stat.addline("Убийств: %s" % kill.get(uid,0))
		stat.addline("Смертей: %s" % dead.get(uid,0))
		stat.addline("Любимая пушка: %s" % olwep)
		stat.addline("Бомб взорвано: %s" % bb.get(uid,0))
		stat.addline("Бомб поставлено: %s" % bp.get(uid,0))
		stat.addline("Бомб разминировано: %s" % bd.get(uid,0))
		stat.addline("Заложников спасено: %s" % hosa.get(uid,0))
		stat.addline("Выстрелов, в голову: %s" % hs.get(uid,0))
		stat.addline("Выстрелов, в игроков: %s" % sh.get(uid))
	else:
		stat.addline('',"У вас нет или не учитывается статистика.", False)
	stat.addline("-"*20)
	stat.addline("Нажмите 1 для выхода")
	stat.send(id)

def conwep(wep):
	if wep == "weapon_glock":return "Glock"
	elif wep == "weapon_usp":return "USP"
	elif wep == "weapon_p228":return "228 compact"
	elif wep == "weapon_deagle":return "Disert Eagle"
	elif wep == "weapon_fiveseven":return "FiveSeven"
	elif wep == "weapon_elite":return "Dual Elites"
	elif wep == "weapon_m3":return "M3"
	elif wep == "weapon_xm1014":return "XM1014"
	elif wep == "weapon_mac10":return "Ingram Mac10"
	elif wep == "weapon_tmp":return "TMP"
	elif wep == "weapon_mp5":return "MP5 Navi"
	elif wep == "weapon_ump45":return "Ump45"
	elif wep == "weapon_p90":return "ES C90"
	elif wep == "weapon_famas":return "Famas"
	elif wep == "weapon_galil":return "Galil"
	elif wep == "weapon_scout":return "Scout"
	elif wep == "weapon_m4a1":return "M4A1"
	elif wep == "weapon_ak47":return "Ak47"
	elif wep == "weapon_aug":return "AUG"
	elif wep == "weapon_sg552":return "SG552"
	elif wep == "weapon_sg550":return "SG550"
	elif wep == "weapon_g3sg1":return "G3SG1"
	elif wep == "weapon_awp":return "AWP"
	elif wep == "weapon_m249":return "M249"
	else: return None
def updateWEP(id, wep):
	uid = ids.get(id)
	if uid == 0 or uid == None: return 0
	es.sql("query","base","update wep set val=(val+1) where ucpid='%s' and weapon='%s'" % (uid,wep))
def update(uid):
	if uid == 0: return 0
	if uid not in skill: skill[uid] = 0
	if kill.get(uid,0) > 0 and dead.get(uid,0) > 0:skill[uid] = float(kill.get(uid)) / float(dead.get(uid))
	es.sql("query", "base", "update players set kills=%s, deaths=%s, skill=%s, hs=%s, bp=%s, bd=%s, bb=%s,hosa=%s, sh=%s where ucpid='%s'" % (kill.get(uid,0), dead.get(uid,0), skill.get(uid,0.0), hs.get(uid,0), bp.get(uid,0), bd.get(uid,0), bb.get(uid,0),hosa.get(uid,0), sh.get(uid,0), uid))
# Events ========================================
def player_hurt(ev):
	auid = getUCPID(ev['attacker'])
	if auid != 0:
		if auid not in sh:sh[auid] = 0
		sh[auid] += 1
	uid = getUCPID(ev['userid'])
def weapon_fire(ev):
	uid = getUCPID(ev['userid'])
	msg("weapon_fire uid = %s " % uid)
	if uid != 0:
		msg("%s sh_all" % uid)
def player_spawn(ev):
	name = es.getplayername(ev['userid'])
	uid = getUCPID(ev['userid'])
	if uid != 0 and uid != None: 
		check = es.sql("queryvalue","base","select * from players where ucpid='%s'" % uid)
		if check == None:es.sql("query","base","insert into players(ucpid,name) values('%s','%s');" % (uid, name))
		wepcheck = es.sql("queryvalue","base","select * from wep where ucpid='%s'" % uid)
		if wepcheck == None:insertwep(uid)
		kill[uid] = int(es.sql("queryvalue","base","select kills from players where ucpid='%s'" % uid))
		dead[uid] = int(es.sql("queryvalue","base","select deaths from players where ucpid='%s'" % uid))
		skill[uid] = float(es.sql("queryvalue","base","select skill from players where ucpid='%s'" % uid))
		hs[uid] = int(es.sql("queryvalue","base","select hs from players where ucpid='%s'" % uid))
		bp[uid] = int(es.sql("queryvalue","base","select bp from players where ucpid='%s'" % uid))
		bd[uid] = int(es.sql("queryvalue","base","select bd from players where ucpid='%s'" % uid))
		bb[uid] = int(es.sql("queryvalue","base","select bb from players where ucpid='%s'" % uid))
		hosa[uid] = int(es.sql("queryvalue","base","select hosa from players where ucpid='%s'" % uid))
		sh[uid] = int(es.sql("queryvalue","base","select sh from players where ucpid='%s'" % uid))
def hostage_rescued(ev):
	uid = getUCPID(ev['userid'])
	if uid == 0 or uid == None: return 0
	if uid not in hosa: hosa[uid] = 0
	hosa[uid] += 1
	update(uid)
def player_death(ev):
	at = es.getplayername(ev['attacker'])
	us = es.getplayername(ev['userid'])
	if ev['es_attackerteam'] == ev['es_userteam']:
		add_kill(at, -1, -1)
	else:
		add_kill(at, 1, ev['headshot'])
		add_dead(us)
	updateWEP(at, ev['es_attackerweapon'])
def bomb_defused(ev):
	uid = getUCPID(ev['userid'])
	if uid == 0 or uid == None: return 0
	if uid not in bd: bd[uid] = 0
	bd[uid] += 1
	update(uid)
def bomb_planted(ev):
	uid = getUCPID(ev['userid'])
	if uid == 0 or uid == None: return 0
	if uid not in bp: bp[uid] = 0
	bp[uid] += 1
	update(uid)
def bomb_exploded(ev):
	uid = getUCPID(ev['userid'])
	if uid == 0 or uid == None: return 0
	if uid not in bb: bb[uid] = 0
	bb[uid] += 1
	update(uid)